;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-intermediate-lambda-reader.ss" "lang")((modname class-notes-wed) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #f #t none #f () #f)))

(define-struct martian (name))
;; A Martian is a (make-martian String)
;; Interp:
;; name is the name of the martian
;; Template:
;; martian-fn : Martian -> ??
#|
(define (martian-fn m)
  (...
   (martian-name m)))
|#

;; ListOfMartians

;; A ListOfMartians (LOM) is either
;; -- empty
;; -- (cons Martian LOM)

;; TEMPLATE:
;; lom-fn : LOM -> ??
;; (define (lom-fn lom)
;;   (cond
;;     [(empty? lom) ...]
;;     [else (...
;;             (martian-fn (first lom))
;;             (lom-fn (rest lom)))]))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define-struct mothership (name crew daughters))
(define-struct drone ())

;; A Spaceship is either of the following -
;; - (make-mothership String ListOfMartian ListOfShip)
;; - (make-drone)

;; INTERP:
;; (make-mothership name crew daughters) represents
;;  a mothership, where
;;  name - is the name of the ship.
;;  crew - is the list of crewmembers present in the ship.
;;  daughters - is the list of daughter ships of the ship

;; (make-drone) represents a drone.

;; Template
;; spaceship-fn : Spaceship -> ??

(define (spaceship-fn s)
  (cond
    [(mothership? s) 
     (... (mothership-name s)
          (lom-fn (mothership-crew s))
          (los-fn (mothership-daughters s)))]
    [(drone? s)  ...]))


;; A ListOfSpaceship (LOS) is one of
;--empty
;--(cons Spaceship LOS)

(define (los-fn los)
  (cond
    [(empty? los)...]
    [else
     (...
      (spaceship-fn (first los))
      (los-fn (rest los)))]))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; ship-crew-includes-name? : SpaceShip String -> Boolean
; given : a SpaceShip and a name
; return : true if a Martian with the given name is present in the crew of
; the given SpaceShip
; strategy : Use template for Spaceship on ship, and then use HOF ormap on
;            the crew of the ship
(define (ship-crew-includes-name? ship name)
  (cond
    [(drone? ship) false]
    [else (ormap
           ;; Martian -> Boolean
           (lambda (m) (equal? (martian-name m) name)) 
           (mother-ship-crew ship))]))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (spaceship-fold ms-combine drone-val empty-los-val los-combine s)
  (cond
    [(mothership? s) 
     (ms-combine (mothership-name s)
          (lom-fn (mothership-crew s))
          (los-fold ms-combine drone-val empty-los-val los-combine (mothership-daughters s)))]
    [(drone? s)  drone-val]))


;; A ListOfSpaceship (LOS) is one of
;--empty
;--(cons Spaceship LOS)

(define (los-fold ms-combine drone-val empty-los-val los-combine los)
  (cond
    [(empty? los) empty-los-val]
    [else
     (los-combine
      (spaceship-fold ms-combine drone-val empty-los-val los-combine (first los))
      (los-fold ms-combine drone-val empty-los-val los-combine (rest los)))]))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (ship-deep-crew-has-name? spaceship m-name)
  (cond
     [(mothership? spaceship) (or (ormap
                                   ;;; Martian -> Boolean
                                   (lambda (m)
                                     (equal? m-name (martian-name m)))
                                   (mothership-crew spaceship))
                                  (ormap
                                   ;;; SpaceShip -> Boolean
                                   (lambda (s)
                                     (ship-deep-crew-has-name? s m-name))
                                   (mothership-daughters spaceship)))]
     [(drone? spaceship) false]))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Spaceship String -> Boolean
(define (name-in-fleet? s name)
  (or
   (name-in-crew? s name)
   (cond
     [(mothership? s)
       (ormap
        ;; Martian -> Boolean
        (lambda (x) (name-in-fleet? x name))
        (mothership-daughters s))]
     [(drone? s) false])))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Spaceship String -> Boolean
(define (name-in-fleet? s name)
  (or
   (name-in-crew? s name)
   (cond
     [(mothership? s)
       (ormap
        ;; Martian -> Boolean
        (lambda (x) (name-in-fleet? x name))
        (mothership-daughters s))]
     [(drone? s) false])))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Spaceship -> Spaceship
(define (spaceship-after-mork-removed s)
  (cond
    [(drone? s) s]
    [else
     (make-mothership
      (mothership-name s)
      (mothership-crew s)
      (filter
       ;; Spaceship -> Boolean
       (lambda (d) (not (mork-in-crew? d)))
       (mothership-daughters s)))]))
         
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Spaceship -> Spaceship
; Given a spaceship,
; returns: another spaceship just like the original,
; except that every ship in its fleet who has a crewmember named "Mork" has
; been removed. When a ship is removed from the fleet, so are all its daughters
; and their fleets.
;; strategy: use template for Spaceship + HOFs map, filter.
(define (remove-all-morks s)
  (cond
    [(drone? s) s]
    [else
     (make-mothership
      (mothership-name s)
      (mothership-crew s)
      (filter
       ;; Spaceship -> Boolean
       (lambda (d) (not (mork-in-crew? d)))
       (map remove-all-morks (mothership-daughters s))))]))





